namespace CMSMicroservice.Application.UserRoleCQ.Commands.CreateNewUserRole;
public class CreateNewUserRoleCommandValidator : AbstractValidator<CreateNewUserRoleCommand>
{
    public CreateNewUserRoleCommandValidator()
    {
        RuleFor(model => model.RoleId)
            .NotNull();
        RuleFor(model => model.UserId)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserRoleCommand>.CreateWithOptions((CreateNewUserRoleCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
